*===========================================================;
*Read and pool panel data                                   ;
*updated April 21:                                          ;
*(1) 2010 based on panel_data_pool_update5.sas              ;
*    compress and keep original panel_pool_98_07_updated.zip; 
*(2) update panel_pool_98_07_updated                        ;
*===========================================================;

libname output "D:\china project\sas_output_data";

%include "D:\china project\Panel9807SAS\firm1999_update.sas"/source2;
libname firm1998 xport "D:\china project\Panel9807SAS\firm1998.xpt";
libname firm1999 xport "D:\china project\Panel9807SAS\firm1999.xpt";
libname firm2000 xport "D:\china project\Panel9807SAS\firm2000.xpt";
libname firm2001 xport "D:\china project\Panel9807SAS\firm2001.xpt";
libname firm2002 xport "D:\china project\Panel9807SAS\firm2002.xpt";
libname firm2003 xport "D:\china project\Panel9807SAS\firm2003.xpt";
libname firm2004 xport "D:\china project\Panel9807SAS\firm2004.xpt";
libname firm2005 xport "D:\china project\Panel9807SAS\firm2005.xpt";
libname firm2006 xport "D:\china project\Panel9807SAS\firm2006.xpt";
libname firm2007 xport "D:\china project\Panel9807SAS\firm2007.xpt";

proc copy in=firm1998 out=work; run;
proc copy in=firm1999 out=work; run;
proc copy in=firm2000 out=work; run;
proc copy in=firm2001 out=work; run;
proc copy in=firm2002 out=work; run;
proc copy in=firm2003 out=work; run;
proc copy in=firm2004 out=work; run;
proc copy in=firm2005 out=work; run;
proc copy in=firm2006 out=work; run;
proc copy in=firm2007 out=work; run;

*=============================================================================;
*Create variable names list that includes variables all summary datasets share;
*=============================================================================;
%macro var_lst(lib=, data=);
ods listing close;
ods output variables=&data._lst; 
proc contents data=&lib..&data; run;
run;
ods listing;
data &data._lst;
   set &data._lst;
   length variable1 $40.;
   variable1=upcase(variable);
   drop variable;
run;
%mend;

%var_lst(lib=work, data=firm1998);
%var_lst(lib=work, data=firm1999);
%var_lst(lib=work, data=firm2000);
%var_lst(lib=work, data=firm2001);
%var_lst(lib=work, data=firm2002);
%var_lst(lib=work, data=firm2003);
%var_lst(lib=work, data=firm2004);
%var_lst(lib=work, data=firm2005);
%var_lst(lib=work, data=firm2006);
%var_lst(lib=work, data=firm2007);

data firm1998_lst (rename=(type=type1998 len=len1998 variable1=variable)); set firm1998_lst; keep variable1 type len;  run;
data firm1999_lst (rename=(type=type1999 len=len1999 variable1=variable)); set firm1999_lst; keep variable1 type len;  run;
data firm2000_lst (rename=(type=type2000 len=len2000 variable1=variable)); set firm2000_lst; keep variable1 type len;  run;
data firm2001_lst (rename=(type=type2001 len=len2001 variable1=variable)); set firm2001_lst; keep variable1 type len;  run;
data firm2002_lst (rename=(type=type2002 len=len2002 variable1=variable)); set firm2002_lst; keep variable1 type len;  run;
data firm2003_lst (rename=(type=type2003 len=len2003 variable1=variable)); set firm2003_lst; keep variable1 type len;  run;
data firm2004_lst (rename=(type=type2004 len=len2004 variable1=variable)); set firm2004_lst; keep variable1 type len;  run;
data firm2005_lst (rename=(type=type2005 len=len2005 variable1=variable)); set firm2005_lst; keep variable1 type len;  run;
data firm2006_lst (rename=(type=type2006 len=len2006 variable1=variable)); set firm2006_lst; keep variable1 type len;  run;
data firm2007_lst (rename=(type=type2007 len=len2007 variable1=variable)); set firm2007_lst; keep variable1 type len;  run;

proc sort data=firm1998_lst; by variable; run;
proc sort data=firm1999_lst; by variable; run;
proc sort data=firm2000_lst; by variable; run;
proc sort data=firm2001_lst; by variable; run;
proc sort data=firm2002_lst; by variable; run;
proc sort data=firm2003_lst; by variable; run;
proc sort data=firm2004_lst; by variable; run;
proc sort data=firm2005_lst; by variable; run;
proc sort data=firm2006_lst; by variable; run;
proc sort data=firm2007_lst; by variable; run;

data firm_lst;
   merge firm1998_lst
         firm1999_lst
         firm2000_lst
         firm2001_lst
         firm2002_lst
         firm2003_lst
         firm2004_lst
         firm2005_lst
         firm2006_lst
         firm2007_lst;
   by variable;
run;


*======================================================================================================================================================;
*Visually examine firm_lst and find the following variables with variables types inconsistence among the years                                         ;
*variables         type1998   type1999   type2000   type2001   type2002   type2003   type2004          type2005     type2006   type2007    correct_type;
*account_                                                                            character         character    numeric    character   character   ;  
*affiliat          character  character   character  character  character character  character         character    numeric    character   character   ;
*agricult                                                                            numeric           character    numeric    character   character   ;
*construc                                                                            numeric           character    numeric    character   character   ;
*employe2                                                                            numeric           numeric      numeric    character   numeric     ;
*employee                                                                            numeric           character    numeric    character   numeric     ;
*estate                                                                              numeric           character    numeric    character   character   ;
*main_inc                                                                            numeric           character    numeric    character   numeric     ; 
*manufact                                                                            numeric           character    numeric    character   numeric     ;
*open_mon                                                                            character         character    numeric    character   numeric     ;
*open_yea          numeric    numeric     numeric    numeric     numeric    numeric  numeric           numeric      numeric    character   numeric     ;
*organiza                                                                                              character    numeric    character   character   ;
*others                                                                              numeric           character    numeric    character   character   ;
*plant_nu          numeric    character  character   character  character  character numeric           character    numeric    character   numeric     ;
*registra          numeric    numeric    numeric     numeric    numeric    numeric   numeric           numeric      character  character   numeric     ; 
*restaura                                                                            numeric           character    numeric    character    character   ;
*retailin                                                                            numeric           character    numeric    character   character   ;
*rlevel                                                                                                             numeric    character   character   ;
*state_ow          character  character  character  character  character   character character         character    numeric    character   character   ;
*status                                                                              character         character    numeric    character   character   ; 
*ta                                                                                  numeric           character    numeric    character   numeric     ; 
*total_in                                                                            numeric           character    numeric    character   numeric     ;
*transpor                                                                            numeric           character    NA         character   character   ;
*                                                                                                                                                      ;  
*Oct25 2009: Also notice (1) between 1998-2003, phone has 8 characters long but for 2004-2007 phone has 11 characters long. (2) between 1998-2002, name;
*            has 40 characters long, for 2003 name has 54 characters long, between 2004-2007, name has 60 characters long                              ;
*Do transformation to make them consistent.                                                                                                            ; 
*======================================================================================================================================================;
data firm1998 (rename=(legal_co1=legal_co 
                        name_1  =name  
                        phone_1 =phone));
   set firm1998;
   length legal_co_0 $10. name_1 $60. phone_1 $11.;
   legal_co_0=upcase(compress(legal_co));
   legal_co1  =legal_co_0;
   name_1     =name;
   phone_1    =phone;
   drop legal_co name phone;
run;

data firm1999 (rename=(
                     legal_co1=legal_co 
                     plant_nu1=plant_nu  
                     name_1   =name  
                     phone_1  =phone));
    set firm1999;
    length legal_co_0 $10. name_1 $60. phone_1 $11.;
    plant_nu1 =input(plant_nu , best12.);
    legal_co_0=upcase(compress(legal_co));
    legal_co1  =legal_co_0; 
    name_1     =name;
    phone_1    =phone;
    drop legal_co plant_nu name phone;
run;


data firm2000 (rename=(
               legal_co1=legal_co 
               plant_nu1=plant_nu 
               name_1   =name  
               phone_1=phone));
    set firm2000;
    length legal_co_0 $10. name_1 $60. phone_1 $11.;
    plant_nu1 =input(plant_nu , best12.);
    legal_co_0=upcase(compress(legal_co));
    legal_co1 =legal_co_0; 
    name_1     =name;
    phone_1    =phone;
    drop legal_co plant_nu name phone;
run;

data firm2001 (rename=(
               legal_co1=legal_co 
               plant_nu1=plant_nu 
               name_1   =name  
               phone_1  =phone));
    set firm2001;
    length legal_co_0 $10. name_1 $60. phone_1 $11.;
    plant_nu1 =input(plant_nu , best12.);
    legal_co_0=upcase(compress(legal_co));
    legal_co1  =legal_co_0;
    name_1     =name;
    phone_1    =phone;
    drop legal_co plant_nu name phone;
run;


data firm2002 (rename=(
              legal_co1=legal_co  
              plant_nu1=plant_nu 
              name_1   =name
              phone_1  =phone));
   set firm2002;
   length legal_co_0 $10. name_1 $60. phone_1 $11.;
   tmp=plant_nu;
   if compress(tmp)='0.0' or compress(tmp)='' then tmp='0';
    plant_nu1 =input(tmp , best12.);
    legal_co_0=upcase(compress(legal_co));
    legal_co1  =legal_co_0;
    name_1     =name;
    phone_1    =phone;
    drop legal_co plant_nu name phone tmp;
run;


data firm2003 (rename=(
              legal_co1=legal_co 
              plant_nu1=plant_nu 
              name_1   =name  
              phone_1  =phone));
    set firm2003; 
    length legal_co_0 $10. name_1 $60. phone_1 $11.;
    plant_nu1 =input(plant_nu , best12.);
    legal_co_0=upcase(compress(legal_co));
    legal_co1 =legal_co_0;
    name_1     =name;
    phone_1    =phone;
    drop legal_co plant_nu name phone;
run;


data firm2004 (rename=(legal_co1=legal_co 
                       name_1   =name  
                       phone_1=phone
                       agricult1=agricult 
                       construc1 =construc
                       estate1   =estate 
                       open_mon1 =open_mon
                       others1   =others 
                       restaura1 =restaura
                       retailin1 =retailin
                       transpor1 =transpor));
    set firm2004;
    length legal_co_0 $10. name_1 $60. phone_1 $11.;
    agricult1=put(agricult ,3.);
    construc1 =put(construc,3.);
    estate1   =put(estate  ,3.);
    open_mon1=input(open_mon, best12.);
	others1  =put(others  ,3.);
    restaura1=put(restaura,3.);
    retailin1=put(retailin,3.);
    transpor1=put(transpor,3.);      
    legal_co_0=upcase(compress(legal_co));
    legal_co1  =legal_co_0;
    name_1     =name;
    phone_1    =phone;
	drop legal_co name phone agricult construc estate open_mon others restaura retailin transpor;     
run;


data firm2005 (rename=(
                    legal_co1=legal_co 
                    name_1   =name  
                    phone_1  =phone
                    employee1=employee 
                    main_inc1=main_inc
                    manufact1=manufact 
                    open_mon1=open_mon 
                    plant_nu1=plant_nu 
                    ta1      =ta       
                    total_in1=total_in));
   set firm2005;
   length legal_co_0 $10. name_1 $60. phone_1 $11.;
   employee1=input(employee , best12.);
   main_inc1=input(main_inc , best12.);
   manufact1=input(manufact , best12.);
   open_mon1=input(open_mon , best12.);
   plant_nu1=input(plant_nu , best12.);
   ta1      =input(ta       , best12.);
   total_in1=input(total_in , best12.);
   legal_co_0=upcase(compress(legal_co));
   legal_co1 =legal_co_0;
   name_1    =name;
   phone_1   =phone;
   drop legal_co name phone employee main_inc manufact open_mon plant_nu ta total_in;
run;

data firm2006 (rename=( legal_co1=legal_co 
                        name_1   =name  
                        phone_1  =phone
                        account_1=account_
                        affiliat1=affiliat 
                        agricult1=agricult 
                        construc1=construc 
                        estate1  =estate   
                        organiza1=organiza 
                        others1  =others   
                        registra1=registra 
                        retailin1=retailin 
                        restaura1 =restaura 
                        rlevel1  =rlevel 
                        state_ow1 =state_ow 
                        status1  =status
						legal_co1=legal_co));
   set firm2006;
   length legal_co_0 $10. name_1 $60. phone_1 $11.;
   account_1=put(account_,1.);
   affiliat1=put(affiliat ,2.);
   agricult1=put(agricult ,3.);
   construc1=put(construc ,3.);
   estate1  =put(estate   ,3.);
   organiza1=put(organiza ,1.);
   others1  =put(others   ,3.);
   registra1=input(registra, best12.); 
   restaura1 =put(restaura  ,3.);
   retailin1=put(retailin ,3.);
   rlevel1  =put(rlevel   ,1.);
   state_ow1=put(state_ow ,1.);
   status1  =put(status   ,1.);
   legal_co_0=upcase(compress(legal_co));
   legal_co1 =legal_co_0;
   name_1    =name;
   phone_1   =phone;
   drop  legal_co name phone account_ affiliat agricult construc estate organiza others registra retailin rlevel state_ow status restaura;
run;


data firm2007 (rename=(
                  legal_co1=legal_co 
                  name_1   =name  
                  phone_1  =phone
                  employe21=employe2
                  employee1=employee
                  main_inc1=main_inc  
                  open_mon1=open_mon
                  open_yea1=open_yea
                  ta1      =ta 
                  total_in1=total_in));
   length legal_co_0 $10. name_1 $60. phone_1 $11.;
   set firm2007;
   employe21=input(employe2,best12.);
   employee1=input(employee,best12.);
   main_inc1=input(main_inc,best12.);  
   *manufact1=input(manufact,best12.); *too many irregular values, drop this variable directly from this year;
   open_mon1=input(open_mon,best12.);
   open_yea1=input(open_yea,best12.);
   *registra1=input(registra,best12.);  *too many irregular values, drop this variable directly from this year;
   *plant_nu1=input(plant_nu , best12.); *too many irregular values, drop this variable directly from this year;
   ta1       =input(ta,     best12.); 
   total_in1 =input(total_in,best12.);
   legal_co_0=upcase(compress(legal_co));
   legal_co1  =legal_co_0;
   name_1     =name;
   phone_1    =phone;
   drop  legal_co name phone employe2  employee main_inc manufact open_mon open_yea  registra ta total_in plant_nu;
run;



*===================================================;
*add a combined code used by Brandt et al.          ;
*area_code + postcode+open_yea + industry + product1;
*notice in year 1998 product1 was missing           ;
*===================================================; 
%macro code_combined(year=); 
data firm&year;
set firm&year;
   length code_combined $60.;
   %if &year=1998 %then %do;
   code_combined=compress(area_cod||postcode||open_yea||industry);
   %end;
   %else %do;
   code_combined=compress(area_cod||postcode||open_yea||industry||product1);
   %end;
run;
%mend;
%code_combined(year=2007);
%code_combined(year=2006);
%code_combined(year=2005);
%code_combined(year=2004);
%code_combined(year=2003);
%code_combined(year=2002);
%code_combined(year=2001);
%code_combined(year=2000);
%code_combined(year=1999);
%code_combined(year=1998);




*===============================================;
*Matching Panel Data (Brandt et al. methodology);
*===============================================; 

%macro matched(base_created_ind   =,
                compared_created_ind=,
                yearbase           =,
                yearcompared       =, 
                var                =, 
                final              =);

%if &base_created_ind=1 %then %do;

data firmyearbase_selected_variables;
   set firm&yearbase;
   length zip_pperson_yearbase $30.;
   legal_co_yearbase   =upcase(compress(legal_co))  ;
   company_yearbase    =upcase(compress(name))      ;
   phone_yearbase      =phone                       ;
   zip_pperson_yearbase=compress(postcode||legal_na);
   yearbase            =&yearbase                   ;
   code_combined_yearbase=code_combined             ;
   keep  yearbase legal_co_yearbase  company_yearbase phone_yearbase zip_pperson_yearbase code_combined_yearbase;
run;
%end;

%if &compared_created_ind=1 %then %do;

data firmyearbase_&yearcompared._all; run;

data firm&yearcompared._selected_variables;
   set firm&yearcompared;
   length zip_pperson_yearcompared $30.;
   legal_co_yearcompared   =upcase(compress(legal_co))  ;
   company_yearcompared    =upcase(compress(name))      ;
   phone_yearcompared      =phone                       ;
   zip_pperson_yearcompared=compress(postcode||legal_na);
   yearcompared            =&yearcompared               ;
   code_combined_yearcompared=code_combined             ;
   keep yearcompared legal_co_0 legal_co_yearcompared  company_yearcompared phone_yearcompared zip_pperson_yearcompared code_combined_yearcompared;
run;
%end;

proc sort data=firmyearbase_selected_variables     out=firmyearbase_selected_variables0     nodupkey; by &var._yearbase     ; run;
proc sort data=firm&yearcompared._selected_variables out=firm&yearcompared._selected_variables0 nodupkey; by &var._yearcompared; run;

proc sql;
   create table firmyearbase_&yearcompared  as
   select a.*,
          b.*
   from firmyearbase_selected_variables0 as a, 
        firm&yearcompared._selected_variables0 as b
   where a.&var._yearbase =b.&var._yearcompared; 
quit;


data firmyearbase_&yearcompared._all;
    set firmyearbase_&yearcompared._all
	    firmyearbase_&yearcompared;
run;


proc sort data=firmyearbase_&yearcompared._all      out=firmyearbase_selected_variables1 (keep=&var._yearbase) nodupkey; by &var._yearbase; run;
proc sort data=firmyearbase_selected_variables                                                                                   ; by &var._yearbase; run;

data firmyearbase_selected_variables;
   merge firmyearbase_selected_variables (in=a)
         firmyearbase_selected_variables1 (in=b);
   by &var._yearbase;
   if (a=1 and b^=1) then output;
run;

proc sort data=firmyearbase_&yearcompared._all out=firm&yearcompared._selected_variables1 (keep=&var._yearcompared) nodupkey; by &var._yearcompared; run;
proc sort data=firm&yearcompared._selected_variables                                                                                      ; by &var._yearcompared; run;

data firm&yearcompared._selected_variables;
    merge firm&yearcompared._selected_variables  (in=a)
	      firm&yearcompared._selected_variables1 (in=b);
    by &var._yearcompared;
	if (a=1 and b^=1) then output;
run;


%if &final=1 %then %do;
data firmyearbase_&yearcompared._all_tmp1;
   set firmyearbase_&yearcompared._all;
   match_ind=0;
   if legal_co_yearcompared   =legal_co_yearbase    then match_ind=match_ind+1;
   if company_yearcompared    =company_yearbase     then match_ind=match_ind+1;
   if zip_pperson_yearcompared=zip_pperson_yearbase then match_ind=match_ind+1;
   if phone_yearcompared      =phone_yearbase then do;
       if (substr(zip_pperson_yearcompared,1,6)=substr(zip_pperson_yearbase,1,6))        
       or (compress(substr(zip_pperson_yearcompared,7))=compress(substr(zip_pperson_yearbase,7)))
           then match_ind=match_ind+1;
   end;
   if match_ind>0 and _n_^=1 then output;
run;

data firm&yearcompared._new_code (keep=legal_co_0 legal_co_yearcompared yearbase yearcompared);
    set firmyearbase_&yearcompared._all_tmp1;
	if legal_co_yearcompared^=legal_co_yearbase then legal_co_yearcompared=legal_co_yearbase;
run;

proc sort data=firm&yearcompared tagsort  ; by legal_co_0; run;
proc sort data=firm&yearcompared._new_code; by legal_co_0; run;

data firm&yearcompared;
   merge firm&yearcompared
         firm&yearcompared._new_code;
   by legal_co_0;
   if legal_co_yearcompared^=legal_co then do;
      if legal_co_yearcompared^='' then legal_co=legal_co_yearcompared;
   end;
   drop legal_co_yearcompared yearcompared yearbase; 

run;
%end;

%mend;

*======================================================;
*matching backward: using more recent years as baseyear;
*======================================================; 

%macro loop_matched_descending(yearcompared=);
   %if &yearcompared=2006 %then %do;
       %matched(base_created_ind=1,compared_created_ind=1,yearbase=2007, yearcompared=2006, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=2007, yearcompared=2006, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=2007, yearcompared=2006, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=2007, yearcompared=2006, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=2007, yearcompared=2006, var=phone        ,final=1);
   %end;

   %else %if &yearcompared=2005 %then %do;
       %matched(base_created_ind=1,compared_created_ind=1,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=code_combined,final=0); 
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=phone        ,final=0);
       %matched(base_created_ind=1,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=phone        ,final=1);
   %end; 

   %else %do;
       %matched(base_created_ind=1,compared_created_ind=1,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+1), yearcompared=&yearcompared, var=phone        ,final=0);
       %matched(base_created_ind=1,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+2), yearcompared=&yearcompared, var=phone        ,final=0);
       %matched(base_created_ind=1,compared_created_ind=0,yearbase=%eval(&yearcompared+3), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+3), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+3), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+3), yearcompared=&yearcompared, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared+3), yearcompared=&yearcompared, var=phone        ,final=1);
   %end;
%mend;

%loop_matched_descending(yearcompared=2006);  *match 2006 data with 2007 data         ;
%loop_matched_descending(yearcompared=2005);  *match 2005 data with 2006 and 2007 data;
%loop_matched_descending(yearcompared=2004);  *match 2004 data with 2005 and 2006 data;
%loop_matched_descending(yearcompared=2003);  *match 2003 data with 2004 and 2005 data;
%loop_matched_descending(yearcompared=2002);  *match 2002 data with 2003 and 2004 data;
%loop_matched_descending(yearcompared=2001);  *match 2001 data with 2002 and 2003 data;
%loop_matched_descending(yearcompared=2000);  *match 2000 data with 2001 and 2002 data;
%loop_matched_descending(yearcompared=1999);  *match 1999 data with 2000 and 2001 data;
%loop_matched_descending(yearcompared=1998);  *match 1998 data with 1999 and 2000 data;


*===================================================================;
*add a variable representing match legal_co after descending matches;
*===================================================================;
%macro add_legal_co_descending(year=);
   data firm&year;
      set firm&year;
	  legal_co_descending=legal_co;
	run;
%mend;

%add_legal_co_descending(year=2007);
%add_legal_co_descending(year=2006);
%add_legal_co_descending(year=2005);
%add_legal_co_descending(year=2004);
%add_legal_co_descending(year=2003);
%add_legal_co_descending(year=2002);
%add_legal_co_descending(year=2001);
%add_legal_co_descending(year=2000);
%add_legal_co_descending(year=1999);
%add_legal_co_descending(year=1998);




*======================================================;
*matching forward: using more distant years as baseyear;
*======================================================; 

%macro loop_matched_ascending(yearcompared=);
   %if &yearcompared=1999 %then %do;
       %matched(base_created_ind=1,compared_created_ind=1,yearbase=1998, yearcompared=1999, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=1998, yearcompared=1999, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=1998, yearcompared=1999, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=1998, yearcompared=1999, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=1998, yearcompared=1999, var=phone        ,final=1);
   %end;

   %else %if &yearcompared=2000 %then %do;
       %matched(base_created_ind=1,compared_created_ind=1,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=code_combined,final=0); 
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=phone        ,final=0);
       %matched(base_created_ind=1,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=phone        ,final=1);
   %end; 

   %else %do;
       %matched(base_created_ind=1,compared_created_ind=1,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-1), yearcompared=&yearcompared, var=phone        ,final=0);
       %matched(base_created_ind=1,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-2), yearcompared=&yearcompared, var=phone        ,final=0);
       %matched(base_created_ind=1,compared_created_ind=0,yearbase=%eval(&yearcompared-3), yearcompared=&yearcompared, var=legal_co     ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-3), yearcompared=&yearcompared, var=company      ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-3), yearcompared=&yearcompared, var=zip_pperson  ,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-3), yearcompared=&yearcompared, var=code_combined,final=0);
       %matched(base_created_ind=0,compared_created_ind=0,yearbase=%eval(&yearcompared-3), yearcompared=&yearcompared, var=phone        ,final=1);
   %end;
%mend;


%loop_matched_ascending(yearcompared=1999);  *match 2006 data with 2007 data         ;
%loop_matched_ascending(yearcompared=2000);  *match 2005 data with 2006 and 2007 data;
%loop_matched_ascending(yearcompared=2001);  *match 2004 data with 2005 and 2006 data;
%loop_matched_ascending(yearcompared=2002);  *match 2003 data with 2004 and 2005 data;
%loop_matched_ascending(yearcompared=2003);  *match 2002 data with 2003 and 2004 data;
%loop_matched_ascending(yearcompared=2004);  *match 2001 data with 2002 and 2003 data;
%loop_matched_ascending(yearcompared=2005);  *match 2000 data with 2001 and 2002 data;
%loop_matched_ascending(yearcompared=2006);  *match 1999 data with 2000 and 2001 data;
%loop_matched_ascending(yearcompared=2007);  *match 1998 data with 1999 and 2000 data;



data panel_variables;
    input full_name $1-23 variable $24-31;
	full_name=upcase(full_name);
	rename   =variable||"="||full_name;
    cards;
legal_name             LEGAL_NA
area_code_i            AREA_COD
prefecture             PREFECTU
extension              EXTENSIO
industry_code          INDUSTRY
registration_code      REGISTRA
registration           REGISTR2
state_ownership        STATE_OW
affiliation            AFFILIAT
open_year              OPEN_YEA
open_month             OPEN_MON
account_type           ACCOUNT_
organization           ORGANIZA
plant_number           PLANT_NU
agriculture            AGRICULT
manufacture            MANUFACT
construction           CONSTRUC
transportation         TRANSPOR
retailing              RETAILIN
restaurant             RESTAURA
employee_f             EMPLOYE2
total_income           TOTAL_IN
main_income            MAIN_INC
loss_dummy             LOSS_DUM
new_product            NEW_PROD
value_added            VALUE_AD
current_asset          CURRENT_
short_invest           SHORT_IN
net_receivable         NET_RECE
inventory              INVENTOR
final_product          FINAL_PR
annual_ca              ANNUAL_C
long_invest            LONG_INV
fix_asset              FIX_ASSE
fix_asset_c            FIX_ASS2
fix_asset_cp           FIX_ASS3
depreciation_a         DEPRECIA
depreciation           DEPRECI2
net_fixasset           NET_FIXA
intangible             INTANGIB
total_asset            TOTAL_AS
current_liability      CURRENT2
account_payable        ACCOUNT2
long_liability         LONG_LIA
liability              LIABILIT
collective_k           COLLECTI
enterprise_k           ENTERPRI
individual_k           INDIVIDU
foreign_k              FOREIGN_
sale_revenue           SALE_REV
sale_cost              SALE_COS
sale_tax_fee           SALE_TAX
other_income           OTHER_IN
other_profit           OTHER_PR
sale_expense           SALE_EXP
adm_expense            ADM_EXPE
insurance              INSURANC
office_fee             OFFICE_F
training_fee           TRAINING
finance_fee            FINANCE_
operating_income       OPERATIN
invest_profit          INVEST_P
minor_income           MINOR_IN
net_income             NET_INCO
tax_profit             TAX_PROF
income_tax             INCOME_T
advertisement          ADVERTIS
insurance_job          INSURAN2
house_subsidy          HOUSE_SU
total_wage             TOTAL_WA
main_wage              MAIN_WAG
total_benefit          TOTAL_BE
main_beneift           MAIN_BEN
purchase_tax           PURCHASE
sale_tax               SALE_TA2
intermediate           INTERMED
inter_production       INTER_PR
inter_adm              INTER_AD
inter_operating        INTER_OP
cashinflow_operating   CASHINFL
cashoutflow_operating  CASHOUTF
cashinflow_invest      CASHINF2
cashoutflow_invest     CASHOUT2
cashinflow_finance     CASHINF3
cashoutflow_finance    CASHOUT3
area_code              AREA_CO2
;
run;

proc sort data=panel_variables; by variable; run;
   
data _null_;
   format rename_lst  $char32767.;
   retain rename_lst  '';
   set panel_variables end=last;
   rename_lst=trim(rename_lst)||' '||upcase(rename);
   if last then do;
      call symput('rename_lst', trim(rename_lst))  ;
   end;
run;


data output.panel_pool_98_07_updated (rename=(&rename_lst));
   set firm1998
       firm1999
       firm2000
       firm2001
	   firm2002
	   firm2003
	   firm2004
	   firm2005
	   firm2006
       firm2007;
       length frdm_panel frdm_panel_new $20.;  
	   frdm_panel_new=legal_co;
       frdm_panel=legal_co_0;  *old legal code;
	   legal_co  =legal_co_0;  *old legal code;
       drop legal_co_0 code_combined; 
run;
