set more off
set mem 600m
save temp_tfp,emptyok
use D:\stata\tfp_data.dta,clear
set more off
set logtype text
log using tfp, replace

sort frdm_panel_new
egen id=group(frdm_panel_new)
duplicates drop id year, force
drop if cic_adj==.
sort cic_adj
egen sector=group(cic_adj)
tsset id year
save tfp9807.dta, replace

program define tfp
local i=1

while `i'<=424 {
preserve
keep if sector==`i'
sum sector cic_adj
levpet l_value_added_real, free( l_labor) proxy( l_intermediate_real) capital(l_capital_real) valueadded reps(250)
predict tfp, omega
keep id year tfp
append using temp_tfp
save temp_tfp, replace
restore

local i=`i'+1
}

end

tfp
program drop tfp

log close
